/****************************************************************************
 * Copyright (C), 2014 ΰƼ޹˾
 * Funtionõѧ
 * Author jlicon@qq.com
 * Correct
 * Remark : 
 * Date   : 2016.04.28
*****************************************************************************/
/* include "header file" -----------------------------------------------------*/
#include "myMaths.h"                            // ͷļ
#include "configure.h"                          // ļ

/* Declaration Variable structure --------------------------------------------*/
/* Declaration Variable bit --------------------------------------------------*/
/* Declaration function prototype --------------------------------------------*/
/*************************************************************************************************/ 

/* Explain: ݸʽת: BCDʽתBINʽ
*******************************************************/
uint8 myMaths_BCDToBin(uint8 xcBCD)
{ 
    uint8 tempBIN = xcBCD; 
    tempBIN = ((tempBIN >> 1) & 0x78);
    return(tempBIN + (tempBIN >> 2) + (xcBCD & 0x0f)); 
} 

/* Explain: ݸʽת: BINʽתBCDʽ
*******************************************************/
uint8 myMaths_BinToBCD(uint8 xcBIN) 
{ 
    uint8 tempBCD = 0; 

    while(1) 
    { 
        if(xcBIN >= 10){ 
            xcBIN -= 10; 
            tempBCD += 0x10; 
        }
        else{ 
            tempBCD += xcBIN; 
            break; 
        } 
    } 
    return(tempBCD);
}

/* Explain: ݸʽת: ASCIIַתUincode
*******************************************************/
void myMaths_AsciiToUnicode(uint8 *xcAcii,uint8 *xcUnicode,uint8 xcLeng) 
{ 
    uint8 i;

    for (i = 0; i < xcLeng;i++) {
        xcUnicode[(i * 4) + 0] = '0';xcUnicode[(i * 4) + 1] = '0';
        xcUnicode[(i * 4) + 2] = '3';xcUnicode[(i * 4) + 3] = xcAcii[i];
    }
}


/* Explain: е
*******************************************************/
void myMaths_ClearBuffer(uint8 *xcBuf,uint16 xcLeng) 
{ 
    while (xcLeng > 0) 
    { 
        *xcBuf = 0x00;       // ջ
        xcLeng --;xcBuf++;   // ޸ַָ
    } 
}


/* Title  : myCopyBuf
 * Explain: һдһ
 * Input  : *xcBuf  - дĻ׵ַ
 *          *xcBuf1 - ԴĻ׵ַ
 *          xcLeng  - ݳ 
*******************************************************/
void myCopyBuf(uint8 *xcBuf,uint8 *xcBuf1,uint16 xcLeng)
{
	while(xcLeng > 0)
    {
        *xcBuf = *xcBuf1;           // д
        xcBuf++;xcBuf1++;           // ַָһ
        xcLeng--;                   // д1
    }
}

//116תΪַ
//hex:16,0~15;
//ֵ:ַ

/* Title  : myMaths_HexToCharacter
 * Explain: 116תΪַ
 * Input  : xcHex  - 16,0~15;
 * Output :        - ַ
*******************************************************/
uint8 myMaths_HexToCharacter(uint8 xcHex)
{
	if(xcHex<=9)return xcHex+'0';
	if((xcHex>=10) && (xcHex<=xcHex))return (xcHex-10+'A'); 
	return '0';
}





/* Title  : myCopyBuf
 * Explain: һָдһ
 * Input  : *xcBuf  - дĻ׵ַ
 *          xcDat   - Դ
 *          xcLeng  - ݳ 
*******************************************************/
void myWriteValueToUint8Buf(uint8 *xcBuf, uint8 xcDat, uint16 xcLeng)
{
	while(xcLeng > 0)
    {
        *xcBuf = xcDat;             // д
        xcBuf++;                    // ַָһ
        xcLeng--;                   // д1
    }
}

/* Title  : Maths_HexToDecString
 * Explain: 16ֵת10Ƶַ 
 * InPut  : *xcStr :ַʼָ,תɵݱλ 
 *          xcDat  :16 
 * Other  : ݵΪ7λ
*******************************************************/
void myMathsHexToDecString(uint8 *xcStr, uint32 xcDat) 
{
    uint8 i = 0;
    uint32 Leng = 0;              
    if ( xcDat < 10) {
        Leng = 1;
    }else if ( xcDat < 100) {
        Leng = 10;
    }else if ( xcDat < 1000) {
        Leng = 100;
    }else if ( xcDat < 10000) {
        Leng = 1000;
    }else if ( xcDat < 100000) {
        Leng = 10000;
    }else if ( xcDat < 1000000) {
        Leng = 100000;
    }else if ( xcDat < 10000000) {
        Leng = 1000000;
    }else if ( xcDat < 100000000) {
        Leng = 10000000;
    }else if ( xcDat < 1000000000) {
        Leng = 100000000;
    }
    while (1) {
        xcStr[i] = (xcDat / Leng) + '0';// 
        xcDat %= Leng; Leng /= 10; i++; // 
        if (Leng == 0) {                // Ƿ
            break;                      // ɽж˳
        }
    }
}

///* Title  : myMaths_unicode_GBK_Exchange
// * Explain: unicodegbk֮ת
// * InPut  : src  - ַ
// *          mode - 0:unicodegbkת;  1:gbkunicodeת;
// * Output : (uni2gbkʱΪgbk,gbk2uniʱ,Ϊunicodeַ)
//*******************************************************/
//void myMaths_unicode_GBK_Exchange(uint8 *src,uint8 *dst,uint8 mode)
//{
//    uint16 temp;
//    uint8  buf[2];
//    if(mode)//gbk 2 unicode
//    {
//        while(*src!=0)
//        {
//            if(*src<0X81)   //Ǻ
//            {
//                temp=(u16)ff_convert((WCHAR)*src,1);
//                src++;
//            }else           //,ռ2ֽ
//            {
//                buf[1]=*src++;
//                buf[0]=*src++;
//                temp=(u16)ff_convert((WCHAR)*(u16*)buf,1);
//            }
//            *dst++=myMaths_HexToCharacter((temp>>12)&0X0F);
//            *dst++=myMaths_HexToCharacter((temp>>8)&0X0F);
//            *dst++=myMaths_HexToCharacter((temp>>4)&0X0F);
//            *dst++=myMaths_HexToCharacter(temp&0X0F);
//        }
//    }
//    else    //unicode 2 gbk
//    {
//        while(*src!=0)
//        {
//            buf[1] =myMaths_HexToCharacter(*src++)*16;
//            buf[1]+=myMaths_HexToCharacter(*src++);
//            buf[0] =myMaths_HexToCharacter(*src++)*16;
//            buf[0]+=myMaths_HexToCharacter(*src++);
//            temp   =(u16)ff_convert((WCHAR)*(u16*)buf,0);
//
//            if(temp<0X80){*dst=temp;dst++;}
//            else {*(u16*)dst=swap16(temp);dst+=2;}
//        }
//    }
//    *dst=0;//ӽ
//}

/* Title  : myMathsDecStringToHex
 * Explain: 10Ƶַת16ֵ
 * InPut  : *xcStr :ַʼָ,תɵݱλ 
 * OutPut : תõ
*******************************************************/
uint32 myMathsDecStringToHex(uint8 *xcStr) 
{
    uint32 tempDat = 0;
    while(*xcStr != 0x00){                                                     
        tempDat = ((tempDat * 10) + (*xcStr - '0'));
        xcStr++;
    }
    return tempDat;
}

/******************* (C) COPYRIGHT 2014 ΰƼ޹˾ *****END OF FILE****/

