/*******************************************************************************
** @file   : main.c
** @author : MCD Application Team
** @version: V1.3.0
** @date   : 2016.08.23
** @brief  : Main program body
********************************************************************************
** @attention
**
**
*******************************************************************************/
/* Includes ------------------------------------------------------------------*/
//#include "systemTask.h"
#include <stdbool.h>


/* FreeRtos includes */
#include "FreeRTOS.h"
#include "task.h"
#include "semphr.h"



#include "MT_COM.h"
#include "MT_FLASH.h"
#include "MT_VS1003.h"
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
#define DEBUG_MODULE "SYSTAKE"
/* Private macro -------------------------------------------------------------*/

/* Private variables ---------------------------------------------------------*/
//static bool canFly;
static bool isInit;


struct worker_work {
  void (*function)(void*);
  void* arg;
};




/* System wide synchronisation */
xSemaphoreHandle canStartMutex;
/* Private function prototypes -----------------------------------------------*/
 
/* Private functions ---------------------------------------------------------*/

// This must be the first module to be initialized!
void sysInit(void)
{
    if(isInit)return;                                                           // ֮ǰǷʼ
    
    canStartMutex = xSemaphoreCreateMutex();                                    //  
    xSemaphoreTake(canStartMutex, portMAX_DELAY);                               // ȡź
    

    isInit = true;
}

void sysTask(void *arg)
{
    bool pass = true;
    //Init the high-levels modules
    sysInit();
    
    mtc_Init();
    mtf_Init();
    mtv_Init(); 
//  workerLoop();
}



void workerLoop(void)
{
    struct worker_work work;

    while (1)
    {
        if (work.function)
            work.function(work.arg);
    }
}








/* Public functions ----------------------------------------------------------*/
void sysLaunch(void)
{
    xTaskCreate(sysTask, "sysTask",configMINIMAL_STACK_SIZE, NULL,tskIDLE_PRIORITY, NULL);
}





/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/

